window.addEventListener( "load", function(){
	
	// set install time if need
	if( fvdSpeedDial.Prefs.get("sd.install_time") == null ){		
		fvdSpeedDial.Prefs.set("sd.install_time", new Date().getTime());
		
		fvdSpeedDial.Prefs.set( "widgets.opened", false ); // hide widget tab for new users		
		fvdSpeedDial.Prefs.set( "sd.display_superfish", true );
		
		chrome.management.get("idgeoanibcknhniccgaoaiolihidecjn", function( app ){
		   
            if( app ){                
                // speed dial installed by app(maybe)
                return;
            }
               
            // open home window
            chrome.tabs.create({
                url: "http://flashvideodownloader.org/fvd-suite/to/s/chrome_sp_wlc/",
                active: true
            });        

		    
		});

		
		fvdSpeedDial.Prefs.set( "display_themes_message", false );
		setTimeout( function(){
			fvdSpeedDial.Prefs.set( "display_themes_message", true );
		}, 2 * 60 * 1000 );
	}
	
	fvdSpeedDial.Localizer.localizeCurrentPage();
	fvdSpeedDial.Dialogs.initPrototypes();
	fvdSpeedDial.Storage.MostVisited.init();
	
	fvdSpeedDial.Storage.connect( function(){
		// rebuild context menu
		fvdSpeedDial.ContextMenu.rebuild();		
	} );
	
	fvdSpeedDial.Storage.addGroupsCallback( function(){
		// rebuild contextmenu for any db change
		fvdSpeedDial.ContextMenu.sheduleRebuild();	
	} );
	
	fvdSpeedDial.Storage.addDialsCallback( function( message ){
		// rebuild contextmenu for any db change
		if( message.action == "remove" ){
			try{
				fvdSpeedDial.HiddenCaptureQueue.removeFromQueueById( message.data.id );	
			}
			catch( ex ){

			}			
		}
	} );
	
	// add deny callback	
	fvdSpeedDial.Storage.addDenyCallback(function( data ){
		
		fvdSpeedDial.Storage.RecentlyClosed.checkDenyAll(function(){
				
			fvdSpeedDial.Storage.refreshDenyDials( function(){

				fvdSpeedDial.Storage.MostVisited.invalidateCache();
				
				fvdSpeedDial.Observer.sendToAllExcludeCurrent( {
					message: "forceRebuild",
					needActiveTab: true
				} );
				
			});
			
		});
		
	});	
	
	// add groups change callback
	
	fvdSpeedDial.Storage.addGroupsCallback(function( data ){
		
		if( data.action == "remove" ){
			
			// check if groups is default group
			if( data.groupId == fvdSpeedDial.Prefs.get( "sd.default_group" ) ){
				fvdSpeedDial.Storage.groupsList(function( groups ){
					var group = groups[0];
					var newId = group.id;
					
					fvdSpeedDial.Prefs.set( "sd.default_group", newId )					
				});
			}
			else{
				// rebuild active speeddial tab
				fvdSpeedDial.Observer.sendToAllExcludeCurrent( {
					message: "forceRebuild",
					resetActiveGroup: true,					
					needDisplayType: "speeddial"
				} );
			}
			
		}
		
	});
	
	// add prefs change callback
	
	fvdSpeedDial.Prefs.addChangeListener(function( name, value ){		
		if( ["sd.enable_top_sites", "sd.enable_most_visited", "sd.enable_recently_closed"].indexOf(name) != -1 ){
			
			var enableSpeedDial = _b(fvdSpeedDial.Prefs.get( "sd.enable_top_sites" ));
			var enableMostVisited = _b(fvdSpeedDial.Prefs.get( "sd.enable_most_visited" ));
			var enableRecentlyClosed = _b(fvdSpeedDial.Prefs.get( "sd.enable_recently_closed" ));		
			
			var disabledItems = [];
			if( !enableSpeedDial ){
				disabledItems.push( "speeddial" );
			}
			if( !enableMostVisited ){
				disabledItems.push( "mostvisited" );
			}					
			if( !enableRecentlyClosed ){
				disabledItems.push( "recentlyclosed" );
			}	
			
			try{				
				var type =  fvdSpeedDial.Utils.arrayDiff(["speeddial", "mostvisited", "recentlyclosed"], disabledItems);
				type = type[0];
				
				if( disabledItems.indexOf( fvdSpeedDial.Prefs.get("sd.display_type") ) != -1 ){
					// default display type is disabled
					fvdSpeedDial.Prefs.set("sd.display_type", type);
				}		
				if( disabledItems.indexOf( fvdSpeedDial.Prefs.get("sd.last_selected_display_type") ) != -1 ){
					// last selected display type is disabled
					fvdSpeedDial.Prefs.set("sd.last_selected_display_type", type);
				}		

			}
			catch( ex ){
				
			}
			
			// rebuild active newtab
			fvdSpeedDial.Observer.sendToAllExcludeCurrent( {
				message: "forceRebuild",
				needActiveTab: true
			} );

		}	
		else if( name == "sd.scrolling" ){
			
			fvdSpeedDial.Prefs.set( "sd.recentlyclosed_columns", "auto" );
			fvdSpeedDial.Prefs.set( "sd.top_sites_columns", "auto" );
			
		}
		else if( name == "sd.display_popular_group" ){
				
			fvdSpeedDial.Utils.Async.chain([
			
				function( chainCallback ){
					if( 0 == fvdSpeedDial.Prefs.get( "sd.default_group" ) ){
						fvdSpeedDial.Storage.groupsList(function( groups ){
							var group = groups[0];
							var newId = group.id;
							
							fvdSpeedDial.Prefs.set( "sd.default_group", newId )					
							
							chainCallback();							
						});
					}
					else{
						chainCallback();
					}
				},
				
				function(){
						
					// rebuild active speeddial tab
					fvdSpeedDial.Observer.sendToAllExcludeCurrent( {
						message: "forceRebuild",
						resetActiveGroup: true,					
						needDisplayType: "speeddial"
					} );
					
				}
			
			]);
			
		}	
	});	
	
	
	// init browser action
	chrome.browserAction.onClicked.addListener(function(){
		
		var foundTabId = null;
		
		fvdSpeedDial.Utils.Async.chain([
		
			function( chainCallback ){
				
				chrome.tabs.query( {
					url: "chrome://newtab/"
				}, function( tabs ){
						
					if( tabs.length > 0 ){
						
						foundTabId = tabs[0].id;
						foundTabIndex = tabs[0].index;
						
					}
					
					chainCallback();
						
				} );
				
			},

			function( chainCallback ){
				
				chrome.tabs.query( {
					url: chrome.extension.getURL( "newtab.html" )
				}, function( tabs ){
						
					if( tabs.length > 0 ){
						
						foundTabId = tabs[0].id;
						
					}
					
					chainCallback();
						
				} );
				
				
			},
			
			function(){
				
				if( !foundTabId ){
					//fvdSpeedDial.Utils.Opener.activeTab( "newtab.html#force-display" );
					
					
					chrome.tabs.query( {
						active: true
					}, function( tabs ){
						
						chrome.tabs.create({
							url: "newtab.html#force-display",
							index: tabs[0].index
						}, function(){
						
							chrome.tabs.remove( tabs[0].id, function(){							
								
							} );
							
						});
																		
					} );
					
				}
				else{
					chrome.tabs.update( foundTabId, {
						active: true
					} );
				}
				
			}
		
		]);
		
	
	});
	
	// force refresh tabs with speed dial
	
	var refreshUrls = [
		"dragon://newtab/", // Comodo dragon
		"chrome://newtab/"
	];
	
	refreshUrls.forEach( function( url ){
		
		chrome.tabs.query( {
			url: url
		}, function( tabs ){

			for( var i = 0; i != tabs.length; i++ ){
				chrome.tabs.update(tabs[i].id, {
					url: chrome.extension.getURL( "newtab.html" )
				});
				
				/*
				chrome.tabs.reload( tabs[i].id, {
					bypassCache: true
				} );
				*/
			}
			
		} );
		
	} );	
	
	
	// adaptations
	if( ["custom", "list"].indexOf( fvdSpeedDial.Prefs.get("sd.thumbs_type") ) == -1 ){
		fvdSpeedDial.Prefs.set( "sd.custom_dial_size", fvdSpeedDial.SpeedDial._cellsSizes[ fvdSpeedDial.Prefs.get("sd.thumbs_type") ] );
		fvdSpeedDial.Prefs.set( "sd.thumbs_type", "custom" );
	}
	
	if( ["custom", "list"].indexOf( fvdSpeedDial.Prefs.get("sd.thumbs_type_most_visited") ) == -1 ){
		fvdSpeedDial.Prefs.set( "sd.thumbs_type_most_visited", "custom" );
	}
		
	
/*
	fvdSpeedDial.Storage.backupTables( ["dials", "groups"], 1, function(){
		console.log( "backuped" );
	} );
*/
		
/*
	fvdSpeedDial.Storage.restoreBackup( 1, function(){
		console.log( "Restored" );
	} );
*/

/*
	fvdSpeedDial.Storage.removeBackup( 1, function(){
		console.log( "Removed" );
	} );
*/

/*
	fvdSpeedDial.Storage.restoreBackupInitial( function(){
		console.log( "Restored initial" );
	} );
*/	
	
	// surfcanyon listener
	chrome.extension.onMessage.addListener(function( message, sender, callback ){
		if( message && message.action == "isSurfCanyonEnabled" ){			
			callback( _b( fvdSpeedDial.Prefs.get("surfcanyon.enabled") ) );
			return true;
		}
	});
	
	// check sync activity state
	
	function _refreshSyncActivityState(){
		var active = fvdSpeedDial.Sync.isActive();
		
		fvdSpeedDial.Storage._markRemove = active;
	}
	
	_refreshSyncActivityState();
	
	fvdSpeedDial.Sync.onActivityStateChanged.addListener(function(){
		
		_refreshSyncActivityState();
		
	});
	
	
}, true	);