if (chrome.extension.getBackgroundPage() == window) {
		
	const MAX_SIMULTANEUSELY_CAPTURES = 1;
		
	fvdSpeedDial.HiddenCaptureQueue = new function(){
						
		var queue = [];
		var currentItem = null;
		var nowCapturesInProgressCount = 0;
		var self = this;
		
		var ignoreIdsAfterComplete = [];
			
		// Events			
		this.onCaptureFinished = new EventEmitter();
		
		function checkNeedIgnoreIdAndRemove( id ){
			var removeIndex = ignoreIdsAfterComplete.indexOf( id );
			if( removeIndex != -1 ){
				ignoreIdsAfterComplete.splice( removeIndex, 1 );
				
				return true;
			}
			
			return false;
		}
		
		function captureNext(){
			
			if( nowCapturesInProgressCount >= MAX_SIMULTANEUSELY_CAPTURES ){
				return;
			}
			
			if( queue.length == 0 ){
				return;
			}
			
			var item = queue.shift();
			
			currentItem = item;
			nowCapturesInProgressCount++;
			
			fvdSpeedDial.HiddenCapture.capture( item.params, function( resultData ){
				
				if( !checkNeedIgnoreIdAndRemove( currentItem.id ) ){	
					self.onCaptureFinished.callListeners( item.params, resultData );
					
					if( item.callback ){
						item.callback( dataUrl );
					}						
				}
				
				currentItem = null;
				
				nowCapturesInProgressCount--;
				captureNext();
				
			} );
			
		}
		
		this.removeFromQueueById = function( id ){
			
			if( currentItem.id == id ){
				ignoreIdsAfterComplete.push( id );
				return;
			}
			
			var index = -1;
			
			for( var i = 0; i != queue.length; i++ ){
				
				if( queue[i].id == id ){
					index = i;
					break;
				}
				
			}
			
			if( index != -1 ){
				queue.splice( index, 1 );
			}			
			
		}
		
		this.getQueue = function(){
			return queue;
		}
		
		this.getCurrentItem = function(){
			return currentItem;
		}
		
		this.capture = function( params, callback ){
			
			checkNeedIgnoreIdAndRemove( params.id );
			
			queue.push({
				id: params.id,
				params: params,
				callback: callback
			});
			
			captureNext();
			
		}	
		
	}
	
}
else{
	fvdSpeedDial.HiddenCaptureQueue = chrome.extension.getBackgroundPage().fvdSpeedDial.HiddenCaptureQueue;
}
