fvdSpeedDial.Introduction = new function(){
	
	const SLIDES = [
	
		{
			title: _("newtab_introduction_slide1_title"),
			text: _("newtab_introduction_slide1_text") 
		},	
		{
			title: _("newtab_introduction_slide2_title"),
			text: _("newtab_introduction_slide2_text")
		}		
	
	];
	
	var currentSlideIndex = -1;
	
	function show(){
		
		document.getElementById("introductionOverlay").setAttribute("appear", 1);		
		buildImages();
		
		selectSlide(0);
		
	}
	
	function hide(){
		
		fvdSpeedDial.Prefs.set( "donotshowintro", true );
		var overlay = document.getElementById("introductionOverlay");
				
		overlay.style.opacity = 0;
		
		setTimeout( function(){
			
			overlay.removeAttribute("appear");	
			
		}, 200 );
		
	}
	
	function selectSlide( index ){
		
		currentSlideIndex = index;
		
		var imgContainer = document.querySelector( "#introductionOverlay .imageContainer" );
		var images = imgContainer.getElementsByTagName( "img" );
		
		for( var i = 0; i != images.length; i++ ){
			if( i == index ){
				images[i].setAttribute( "appear", 1 );	
			}
			else{
				images[i].setAttribute( "appear", 0 );	
			}
		}
		
		var data = SLIDES[index];
		
		var titleContainer = document.querySelector( "#introductionDialog .slideTitle" );
		var textContainer = document.querySelector( "#introductionDialog .slideText" );	
		
		titleContainer.innerHTML = data.title;	
		textContainer.innerHTML = data.text;	
		
		refreshButtons();		
		
	}
	
	function buildImages(){
		
		var container = document.querySelector( "#introductionOverlay .imageContainer" );
		while( container.firstChild ){
			container.removeChild( container.firstChild );
		}
		
		for( var i = 0; i != SLIDES.length; i++ ){
			var img = new Image();
			img.src = "images/newtab/introduction/slide"+(i+1)+".png";
			img.setAttribute( "slide", i );
			container.appendChild( img );
		}
		
	}
	
	function refreshButtons(){
		var prev = document.querySelector( "#introductionDialog .buttons .prev" );
		var next = document.querySelector( "#introductionDialog .buttons .next" );
		var start = document.querySelector( "#introductionDialog .buttons .start" );				
		
		if( currentSlideIndex == 0 ){
			prev.setAttribute( "appear", 0 );
		}
		else{
			prev.setAttribute( "appear", 1 );
		}
		
		if( currentSlideIndex < SLIDES.length - 1 ){
			next.setAttribute( "appear", 1 );
		}
		else{
			next.setAttribute( "appear", 0 );
		}
		
		if( currentSlideIndex == SLIDES.length - 1 ){
			start.setAttribute( "appear", 1 );
		}
		else{
			start.setAttribute( "appear", 0 );
		}
		
	}
	
	window.addEventListener( "load", function(){
		
		if( _b( fvdSpeedDial.Prefs.get( "donotshowintro" ) ) ){
			return;
		}
		
		show();
		
		document.querySelector( "#introductionDialog .buttons .next" ).addEventListener("click", function(){			
			selectSlide( currentSlideIndex + 1 );				
		}, false);
		document.querySelector( "#introductionDialog .buttons .prev" ).addEventListener("click", function(){			
			selectSlide( currentSlideIndex - 1 );				
		}, false);
		document.querySelector( "#introductionDialog .buttons .start" ).addEventListener("click", function(){			
			hide();		
		}, false);		
		document.querySelector( "#introductionDialog .close" ).addEventListener("click", function(){			
			hide();		
		}, false);
		
	} );
	
}
