if (chrome.extension.getBackgroundPage() == window) {

	fvdSpeedDial.SpeedDial.ThumbManager = new function(){
		
		// lister to capture finished		
		function onHiddenCaptureFinished(params, resultData){
			
			// update info in db
						
			if( resultData && params.id && params.type ){
				
				var dataUrl = resultData.dataUrl;
				var title = resultData.title;
				var thumbSize = resultData.thumbSize;
							
				switch( params.type ){
					
					case "speeddial":
						
						fvdSpeedDial.Storage.getDial( params.id, function( oldDial ){
							
							if( !oldDial ){
								return;
							}
							
							var resultData = {
								"auto_title": title
							};
													
							if( oldDial ){
								
								if( !oldDial.title && oldDial.auto_title != title ){
									// need to sync dials where changed auto title
									fvdSpeedDial.Sync.addDataToSync( "dials", params.id, {translate: "dial"} );
								}
								
							}
							
							if (params.saveImage) {
								resultData.thumb = dataUrl;
								resultData.screen_maked = 1;
								resultData.thumb_width = thumbSize.width;
								resultData.thumb_height = thumbSize.height;
							}							
														
							fvdSpeedDial.Storage.updateDial(params.id, resultData, function(){
								
							});
							
						} );
						
					break;
					
					case "mostvisited":
										
						var resultData = {
							"auto_title": title
						};
						
						if (params.saveImage) {
							resultData.thumb_source_type = "screen";
							resultData.thumb = dataUrl;
							resultData.screen_maked = 1;
							resultData.thumb_width = thumbSize.width;
							resultData.thumb_height = thumbSize.height;
						}
						
						fvdSpeedDial.Storage.MostVisited.updateData(params.id, resultData, function(){
					
							
							
						});
					
					break;
					
				}
				
			}
			
		}
		
		fvdSpeedDial.HiddenCaptureQueue.onCaptureFinished.addListener(onHiddenCaptureFinished);		
		window.addEventListener("unload", function(){
			fvdSpeedDial.HiddenCaptureQueue.onCaptureFinished.removeListener(onHiddenCaptureFinished);
		});
		
		function isQueued( params ){
			
			var queue = fvdSpeedDial.HiddenCaptureQueue.getQueue();
			var currentItem = fvdSpeedDial.HiddenCaptureQueue.getCurrentItem();
			
			if( currentItem ){
				if( currentItem.params.type == params.type && currentItem.params.id == params.id ){
					return true;
				}				
			}
			
			for( var i = 0; i != queue.length; i++ ){
				var item = queue[i];
				if( item.params.type == params.type && item.params.id == params.id ){
					return true;
				}
			}
			
			return false;
			
		}
		
		this.hiddenCaptureThumb = function( aParams, callback ){
			
			if( typeof aParams.saveImage == "undefined" ){
				aParams.saveImage = true;
			}
			
			if( typeof aParams.resetScreenMaked == "undefined" ){
				aParams.resetScreenMaked = true;
			}
			
			fvdSpeedDial.Utils.Async.chain([
				
				function( chainCallback ){
					
					if( aParams.resetScreenMaked ){
						
						if( aParams.type == "speeddial" ){
							fvdSpeedDial.Storage.updateDial( aParams.data.id, {
								screen_maked: 0
							}, function(){
								chainCallback();
							} );							
						}
						else if( aParams.type == "mostvisited" ){
							fvdSpeedDial.Storage.MostVisited.updateData( aParams.data.id, {
								screen_maked: 0
							}, function(){
								chainCallback();
							} );
						}

					}
					else{
						chainCallback();
					}
					
				},
				
				function( chainCallback ){
											
					if( aParams.data.url ){
						chainCallback();
					}
					else{
						
						if( aParams.type == "speeddial" ){
																						
							fvdSpeedDial.Storage.getDial( aParams.data.id, function( dial ){
																
								aParams.data.url = dial.url;
								aParams.elemId = "dialCell_" +aParams.data.id;
								
								chainCallback();
								
							});
							
						}
						else if( aParams.type == "mostvisited" ){
														
							fvdSpeedDial.Storage.MostVisited.getById( aParams.data.id, aParams.interval, "host", function( row ){
															
								aParams.data.url = row.url;
								aParams.elemId = "dialCell_" +aParams.data.id;
								
								chainCallback();
								
							});
							
						}
						
					}
					
				},
				function(){
					
					var data = aParams.data;
					var elem = aParams.elem;
							
					if( elem ){
						if( aParams.saveImage ){
							elem.setAttribute("loadscreen", 1);	
							
							var screen = elem.querySelector(".body .screen");		
							if( screen ){
								fvdSpeedDial.Utils.removeScreenPreview(screen);									
							}						
						}						
					}
					
					var params = {
						url: data.url,
						id: data.id,
						elemId: aParams.elemId || elem.getAttribute("id"),
						type: aParams.type,
						saveImage: aParams.saveImage,
						interval: aParams.interval
					};
					
					if( !isQueued( params ) ){
						fvdSpeedDial.HiddenCaptureQueue.capture( params, callback );				
					}
					else{
					}
					
				}
				
			]);
			
		}
		
		this.setThumbToElement = function(params){
		
			var data = params.data;
			var elem = params.elem;
			
			var screen = elem.querySelector(".body .screen");
			
			if (data.thumb_source_type == "screen") {
				if (data.screen_maked != 1) {
	
					if( data.get_screen_method == "manual" ){
						elem.setAttribute("noscreen", 1);		
					}
					else{
						this.hiddenCaptureThumb( {
							elem: elem,
							data: data,
							type: elem.getAttribute("type"),
							saveImage: true,
							resetScreenMaked: false,
							interval: params.interval
						} );							
					}				
				
				}
				else {
					// setup screen
					if( screen ){
						fvdSpeedDial.Utils.setScreenPreview(screen, data.thumb);						
					}
				}
			}
			else {
				
				if( screen ){
					
					if (data.thumb_source_type == "url" || data.thumb_source_type == "local_file") {
						fvdSpeedDial.Utils.setUrlPreview({
							elem: screen,
							size: params.cellSize
						}, {
							url: data.thumb,
							size: {
								width: data.thumb_width,
								height: data.thumb_height
							}
						});
					}
					
					if( !data.displayTitle ){				
						this.hiddenCaptureThumb( {
							elem: elem,
							data: data,
							type: elem.getAttribute("type"),
							saveImage: false,
							resetScreenMaked: false,
							interval: params.interval
						} );	
					}
					
				}
				
			} 			
		}
		
	}
	
}
else{
	fvdSpeedDial.SpeedDial.ThumbManager = chrome.extension.getBackgroundPage().fvdSpeedDial.SpeedDial.ThumbManager;
	
	function onHiddenCaptureFinished(params, resultData){

		if( !params.elemId ){
			return;
		}	
				
		// update info in speeddial			
		var elem = document.getElementById( params.elemId );
		
		if( !elem ){
			return;
		}
		
		fvdSpeedDial.Utils.Async.chain([
			
			function( chainCallback ){
				
				if( params.type == "speeddial" ){
				
					fvdSpeedDial.Storage.getDial( params.id, function( dial ){
						
						if( dial.title ){
							delete resultData.title;
						}
						
						chainCallback();
						
					} );
					
				}
				else if( params.type == "mostvisited" ){
							
					fvdSpeedDial.Storage.MostVisited.getById( params.id, params.interval, "host", function( row ){
														
						fvdSpeedDial.Storage.MostVisited.extendData( row, function( mvData ){
															
							if( mvData.title ){
								delete resultData.title; 
							}
							
							chainCallback();
																
						} );						
						
					} );
					
				}				
				
			},			
			function(){
				
				console.log("enddd");
				
				elem.removeAttribute("loadscreen");
				
				if( !resultData ){
					// failed here
					return;
				}
				
				if( resultData.title ){
					var titleContainer = elem.querySelector(".head span");
					
					if( !titleContainer ){ 
						// try to get titlecontainer for list element
						titleContainer = elem.querySelector(".leftData .text");
					}					
					
					if( titleContainer ){
						titleContainer.textContent = resultData.title;
						elem.removeAttribute("notitle");
					}
				}
				
				var screen = elem.querySelector(".body .screen");		
						
				if( screen && params.saveImage && resultData.dataUrl ){
					fvdSpeedDial.Utils.setScreenPreview(screen, resultData.dataUrl);				
				}
				else{
					
				}	
				
			}
			
		]);		
		
	}
	
	fvdSpeedDial.HiddenCaptureQueue.onCaptureFinished.addListener(onHiddenCaptureFinished);
	
	window.addEventListener("unload", function(){
		fvdSpeedDial.HiddenCaptureQueue.onCaptureFinished.removeListener(onHiddenCaptureFinished);
	});
			
}
