(function(){
	
	var Observer = function(){
		
		if( chrome.extension.getBackgroundPage() == window ){
			this.initBackground();
		}
		else{
			this.init();			
		}
		
	}
	
	Observer.prototype = {
		init: function(){

			chrome.extension.onRequest.addListener( function( request, sender, callback ){
			
				var processRequest = function(){
					try{
						switch( request.message ){
							case "forceRebuild":
								var allow = true;
								if( request.needDisplayType ){
									if( request.needDisplayType != fvdSpeedDial.SpeedDial.currentDisplayType() ){
										allow = false;
									}
								}
								if( allow ){
									function __doRebuild(){
										fvdSpeedDial.SpeedDial.sheduleFullRebuild();
									}
									
									if( request.resetActiveGroup ){
										console.log("FULL Rebuild active");
										
										fvdSpeedDial.SpeedDial.resetCurrentGroupId(function(){
											__doRebuild();
										});
									}
									else{
										__doRebuild();									
									}								
								}								
								
							break;
							case "foundRecentlyClosed":
								
								if( fvdSpeedDial.SpeedDial.currentDisplayType() == "recentlyclosed" ){
									fvdSpeedDial.SpeedDial.sheduleFullRebuild();
								}
								else{
									// else rebuild only misc content
									fvdSpeedDial.SpeedDialMisc.sheduleRebuild();
								}
							break;
							
							case "displayNoSyncGroupAlert":
							

							
							break;
						}					
					}
					catch( ex ){

					}	
				};
				
				if( request.needActiveTab ){
					chrome.tabs.getCurrent(function( tab ){
						if( tab ){
							if( tab.active ){
								processRequest();
							}
						}
					});
				}
				else{
					processRequest();
				}
				
			
			} );
			
		},
		
		initBackground: function(){
			
			chrome.extension.onRequest.addListener( function( request, sender, callback ){
				
				if( request.message == "notifyAll" ){
					
					chrome.extension.sendRequest( request.newRequest, function(){
						
					} );
					
				}
				
			} );
			
		},
		
		sendToAll: function( newRequest ){
			var request = {
				message: "notifyAll",
				newRequest: newRequest
			};
			
			chrome.extension.sendRequest( request, function(){
				
			} );
		},
		
		sendToAllExcludeCurrent: function( request ){			
			chrome.extension.sendRequest( request, function(){
				
			} );
		}
	};
	
	this.Observer = new Observer();
	
}).apply(fvdSpeedDial);
